
/*
 * 2014/10/10 sample-002.c
 */

/*
 *	񎟌s^̒`ƌvZ
 *
 * p@
 *		RpC
 *			cc -Ic:\usr\c\include -o BASENAME.exe sample-002.c
 *		s
 *			BASENAME
 */

#include <stdio.h>

/*
 *
 */

#define	DIMENSION	2			/* 񎟌 */

/*
 *  s A ́A2 x 2 = 4 ̗vfĂ
 *
 *	A = ( 1 2 ) = ( a[0][0] a[0][1] )
 *        3 4       a[1][0] a[1][1]
 *
 */

typedef struct {
	double a[DIMENSION][DIMENSION];		/* 񎟌̍s̗vf 2 x 2 */
} Matrix2D;								/* Matrix2D ^̐錾 */

/*
 * Matrix2D make_Matrix2D ( double a, double b, double c, double d )
 * 		usv쐬
 *
 *		A = ( a b ) = ( a[0][0], a[0][1] )
 *          ( c d )   ( a[1][0], a[1][1] )
 */

Matrix2D make_Matrix2D ( double a, double b, double c, double d ) {
	Matrix2D newMatrix2D;	/* Vs */

	newMatrix2D.a[0][0] = a;
	newMatrix2D.a[0][1] = b;
	newMatrix2D.a[1][0] = c;
	newMatrix2D.a[1][1] = d;

	return newMatrix2D;

}

/*
 * void print_Matrix2D ( Matrix2D ary );
 * 		usv\ (\̓sAɓƗsɏo͂)
 *		Matrix2D ary; 񎟌s
 */

void print_Matrix2D ( Matrix2D ary ) {
	int r;		/* s ( row ) */
	int c;		/*  ( colomun ) */

	for ( r = 0; r < DIMENSION; r++ ) {
		printf ( "(" );
		for ( c = 0; c < DIMENSION; c++ ) {
			 printf ( "  %10.5f", ary.a[r][c] );

		/*
		 * [] %10.5f  %f Ɠ_o͂邪
		 *        uŜ̌ 10 A_ȉ 5 ɂv
		 *        Ƃu\̎wvĂ
         *		  ڂ google Łuprintf vŌ
         */
		}
		printf ( "  )\n" );
	}
}

/*
 * Matrix2D add_Matrix2D ( Matrix2D a1, Matrix2D a2 );
 * 		usv̘a
 *
 *		( a  b ) + ( e  f ) = ( a + e  b + f )
 *		( c  d )   ( g  h )   ( c + g  g + h )
 */

Matrix2D add_Matrix2D ( Matrix2D a1, Matrix2D a2 ) { 
	Matrix2D result;	/* vZ */
	int r;				/* s ( row ) */
	int c;				/*  ( colomun ) */

	for ( r = 0; r < DIMENSION; r++ ) {
		for ( c = 0; c < DIMENSION; c++ ) {
			result.a[r][c] = a1.a[r][c] + a2.a[r][c];
		}
	}

	return result;
}

/*
 *	main
 */

int main( int argc, char *argv[] )
{
		/*
			a1 = (  1  2 )
			     (  3 -1 )
			a2 = ( -3  1 )
			     (  1 -2 )
		*/
	Matrix2D a1 = make_Matrix2D (  1.0,  2.0,  3.0, -1.0 );
	Matrix2D a2 = make_Matrix2D ( -3.0,  1.0,  1.0, -2.0 );

	/* s a1 ƍs a2 ̘avZďo͂ */

	print_Matrix2D ( a1 );
	printf ( " ƁA \n" );
	print_Matrix2D ( a2 );
	printf ( " Ƃ́Aa \n" );
	print_Matrix2D ( a );
	printf ( " łB\n" );

	return 0;
}
